<?php
 
//Find your timezone here : http://php.net/manual/fr/timezones.php
date_default_timezone_set("Europe/Paris");
      
if (isset($argv)) {
     foreach ($argv as $arg) {
         $argList = explode('=', $arg);
         if (isset($argList[0]) && isset($argList[1])) {
             $_GET[$argList[0]] = $argList[1];
         }
     }
 }

if(count($argv) < 5) echo "Arguments invalides!";

$minOrMax = $argv[1]; 
$cmdName = $argv[2];
$start = $argv[3];
$end = $argv[4];
$dateFormat = $argv[5];
$debug = count($argv) > 6 ? $argv[6] : 0;

//Convert jeedom day only to day + time
if( ereg("[0-9]{4}", $start)) $start = $start.' 0000';
if( ereg("[0-9]{4}", $end)) $start = $end.' 0000';

//Eval PHP date format or Jeedom format
$startEval = date('Y-m-d H:i', ereg("[0-9]{4} [0-9]{4}", $start) ? DateTime::createFromFormat('md Hi', $start)->getTimestamp() : strtotime($start)); 
$endEval = date('Y-m-d H:i', ereg("[0-9]{4} [0-9]{4}", $end) ? DateTime::createFromFormat('md Hi', $end)->getTimestamp() : strtotime($end)); 


if($debug) die("{mode: $minOrMax, command: $cmdName, start: $start, startEval: $startEval, end: $end, endEval: $endEval, format: $dateFormat}");
  
require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

$cmdId = cmd::byString("#".$cmdName."#")->getId();
$all = history::all($cmdId, $startEval, $endEval);

if(count($all) == 0) echo "Pas de valeurs sur la période donnée";

$current = $all[0];
for ($i = 0; $i < count($all); $i++) {
  $v = $all[$i];
  if($minOrMax == "max" && $v->getValue() >= $current->getValue())
  	$current = $v;
  if($minOrMax == "min" && $v->getValue() <= $current->getValue())
  	$current = $v;
}

echo date ($dateFormat, strtotime($current->getDatetime()));